needs sdl2constants.fs

\ Instructions
0 constant INST_NOP
1 constant INST_CLEAR       \ 00E0:         Clear screen
2 constant INST_CMP_IMM     \ 3XNN / 4XNN:  Skip if VX == NN / VX <> NN
3 constant INST_CMP_KEY     \ EX9E / EXA1:  Skip if key in VX is / is not pressed
4 constant INST_CMP_REG     \ 5XY0 / 9XY0:  Skip if VX == VY / VX <> VY
5 constant INST_DRAW        \ DXYN:         Draw N-tall sprite from VI at (X, Y)
6 constant INST_GET_KEY     \ FX0a:         Wait for key, store at VX
7 constant INST_GET_TIME    \ FX07:         VX = Current Delay Timer
8 constant INST_GOTO        \ 1NNN:         Goto NNN
9 constant INST_JUMP        \ BNNN:         PC = V0 + NNN
10 constant INST_MOV_IMM    \ 6XNN / 7XNN:  Set VX = NN / VX += NN
11 constant INST_MOV_IMM_I  \ ANNN:         Set VI = NNN
12 constant INST_MOV_REG    \ 8XYO:         Set VX O= Vy
13 constant INST_MOV_REG_I  \ FX1E / FX33:  VI += VX / Store VX digits at VI
14 constant INST_RAND       \ CXNN:         VX = rand() & NN
15 constant INST_REG_DUMP   \ FX55:         Load from V0 to VX to addresses starting at I
16 constant INST_REG_LOAD   \ FX65:         Load to V0 to VX from addresses starting at I
17 constant INST_RETURN     \ 00EE:         Return from subroutine
18 constant INST_SET_SPRITE \ FX29:         VI = Address of character sprite VX
19 constant INST_SET_TIME   \ FX15 / FX18:  delay timer = VX / sound timer = VX
20 constant INST_CALL       \ 2NNN:         Call subroutine at NNN

\ Instruction flags
0 constant FLAG_NONE
1 constant FLAG_ADD
2 constant FLAG_BCD
3 constant FLAG_BIT_AND
4 constant FLAG_BIT_OR
5 constant FLAG_BIT_XOR
6 constant FLAG_DELAY
7 constant FLAG_EQUAL
8 constant FLAG_LSHIFT
9 constant FLAG_NEQUAL
10 constant FLAG_RSHIFT
11 constant FLAG_SOUND
12 constant FLAG_SUB
13 constant FLAG_SUB_INV

\ Keypad
\ Maps the CHIP-8 table to the corresponding keyboard keys
\ Adapt if different keyboard layout is desired
create key-table    SDL_SCANCODE_X , \ 0
                    SDL_SCANCODE_1 , \ 1
                    SDL_SCANCODE_2 , \ 2
                    SDL_SCANCODE_3 , \ 3
                    SDL_SCANCODE_Q , \ 4
                    SDL_SCANCODE_W , \ 5
                    SDL_SCANCODE_E , \ 6
                    SDL_SCANCODE_A , \ 7
                    SDL_SCANCODE_S , \ 8
                    SDL_SCANCODE_D , \ 9
                    SDL_SCANCODE_Z , \ A
                    SDL_SCANCODE_C , \ B
                    SDL_SCANCODE_4 , \ C
                    SDL_SCANCODE_R , \ D
                    SDL_SCANCODE_F , \ E
                    SDL_SCANCODE_V , \ F

