
needs sdl2.fs

NULL value window
NULL value surface
NULL value pixelformat
NULL value white
NULL value black
NULL value sprites
0 value chp8-screen \ screen buffer

: wait { ms -- }
  ms sdl-delay
;

: fill-surface { color -- }
  color black = if
    chp8-screen 8 4 * 8 * erase
  else
    chp8-screen 8 4 * 8 * $ff fill
  endif
  surface NULL color sdl-fillrect assert1( 0 = ) 
;

: set-pixel { x y color -- }
  c-sizeof-rect allocate assert1( 0 = )
  dup c-offsetof-rect-x + x 10 * swap l!
  dup c-offsetof-rect-y + y 10 * swap l!
  dup c-offsetof-rect-w + 10 swap l!
  dup c-offsetof-rect-h + 10 swap l!
  dup surface swap color sdl-fillrect assert1( 0 = )
  
  free assert1( 0 = )
;

: update-surface ( -- )
  32 64 * 0 ?do
    i 64 mod \ x
    i 64 / \ x y
    dup cells chp8-screen + @ \ x y c
    $8000000000000000 i 64 mod rshift \ x y c bitmask
    and 0<> if
      white
    else
      black
    endif
    \ x y color
    set-pixel
  loop
  window sdl-updatewindowsurface assert1( 0 = )
;

: init-sprites
  80 allocate assert0( 0 = ) to sprites
  \ 0
  $f0 sprites 0 + c!
  $90 sprites 1 + c!
  $90 sprites 2 + c!
  $90 sprites 3 + c!
  $f0 sprites 4 + c!
  \ 1
  $20 sprites 5 + c!
  $60 sprites 6 + c!
  $20 sprites 7 + c!
  $20 sprites 8 + c!
  $70 sprites 9 + c!
  \ 2
  $F0 sprites 10 + c!
  $10 sprites 11 + c!
  $F0 sprites 12 + c!
  $80 sprites 13 + c!
  $F0 sprites 14 + c!
  \ 3
  $F0 sprites 15 + c!
  $10 sprites 16 + c!
  $F0 sprites 17 + c!
  $10 sprites 18 + c!
  $F0 sprites 19 + c!
  \ 4
  $90 sprites 20 + c!
  $90 sprites 21 + c!
  $F0 sprites 22 + c!
  $10 sprites 23 + c!
  $10 sprites 24 + c!
  \ 5
  $F0 sprites 25 + c!
  $80 sprites 26 + c!
  $F0 sprites 27 + c!
  $10 sprites 28 + c!
  $F0 sprites 29 + c!
  \ 6
  $F0 sprites 30 + c!
  $80 sprites 31 + c!
  $F0 sprites 32 + c!
  $90 sprites 33 + c!
  $F0 sprites 34 + c!
  \ 7
  $F0 sprites 35 + c!
  $10 sprites 36 + c!
  $20 sprites 37 + c!
  $40 sprites 38 + c!
  $40 sprites 39 + c!
  \ 8
  $F0 sprites 40 + c!
  $90 sprites 41 + c!
  $F0 sprites 42 + c!
  $90 sprites 43 + c!
  $F0 sprites 44 + c!
  \ 9
  $F0 sprites 45 + c!
  $90 sprites 46 + c!
  $F0 sprites 47 + c!
  $10 sprites 48 + c!
  $F0 sprites 49 + c!
  \ A
  $F0 sprites 50 + c!
  $90 sprites 51 + c!
  $F0 sprites 52 + c!
  $90 sprites 53 + c!
  $90 sprites 54 + c!
  \ B
  $E0 sprites 55 + c!
  $90 sprites 56 + c!
  $E0 sprites 57 + c!
  $90 sprites 58 + c!
  $E0 sprites 59 + c!
  \ C
  $F0 sprites 60 + c!
  $80 sprites 61 + c!
  $80 sprites 62 + c!
  $80 sprites 63 + c!
  $F0 sprites 64 + c!
  \ D
  $E0 sprites 65 + c!
  $90 sprites 66 + c!
  $90 sprites 67 + c!
  $90 sprites 68 + c!
  $E0 sprites 69 + c!
  \ E
  $F0 sprites 70 + c!
  $80 sprites 71 + c!
  $F0 sprites 72 + c!
  $80 sprites 73 + c!
  $F0 sprites 74 + c!
  \ F
  $F0 sprites 75 + c!
  $80 sprites 76 + c!
  $F0 sprites 77 + c!
  $80 sprites 78 + c!
  $80 sprites 79 + c!
;

: init-graphics
  8 4 * 8 * allocate assert0( 0 = ) to chp8-screen
  chp8-screen 8 4 * 8 * erase

  SDL_INIT_VIDEO sdl-init
  0 < if
    s\" SDL init error " type
    sdl-geterror type
    s\" \n" type
    -1
  else
    s" Hello SDL2 from Forth0" tocstr
    SDL_WINDOWPOS_UNDEFINED
    SDL_WINDOWPOS_UNDEFINED
    640 320
    SDL_WINDOW_SHOWN
    sdl-createwindow to window
    window NULL = if
      s\" SDL createwindow error " type
      sdl-geterror type
      s\" \n" type
      -1
    else
      window sdl-getwindowsurface to surface
      window sdl-getwindowpixelformat sdl-allocformat to pixelformat
      pixelformat $ff $ff $ff sdl-maprgb to white
      pixelformat $00 $00 $00 sdl-maprgb to black
    endif
  endif
;

: down-graphics
  window sdl-destroywindow
  pixelformat sdl-freeformat
  sdl-quit
;

init-sprites