\ sdl2.fs
\ SDL2 Interface for forth

\ Available prototypes
\ sdl-init ( flags -- error-code )
\ sdl-createwindow ( title x y w h flags -- *window )
\ sdl-geterror ( -- *error-msg )
\ sdl-getwindowsurface ( *window -- *surface )
\ sdl-getwindowpixelformat ( *window -- *pixelformat )
\ sdl-fillrect ( *surface *rect color -- error-code )
\ sdl-maprgb ( *format r g b -- error-code )
\ sdl-updatewindowsurface ( *window -- error-code )
\ sdl-delay (  -- void )
\ sdl-destroywindow ( *window -- )
\ sdl-quit ( -- )

c-library sdl2

s" SDL2" add-lib

\c #include <SDL2/SDL.h>
\c size_t GET_SizeOf_int() { return sizeof(int); }
\c size_t GET_SizeOf_SDL_Rect() { return sizeof(SDL_Rect); }
\c size_t GET_SizeOf_SDL_Event() { return sizeof(SDL_Event); }
\c size_t GET_OffsetOf_SDL_Rect_x() { return offsetof(SDL_Rect, x); }
\c size_t GET_OffsetOf_SDL_Rect_y() { return offsetof(SDL_Rect, y); }
\c size_t GET_OffsetOf_SDL_Rect_w() { return offsetof(SDL_Rect, w); }
\c size_t GET_OffsetOf_SDL_Rect_h() { return offsetof(SDL_Rect, h); }
\c size_t GET_OffsetOf_SDL_KeyboardEvent_keysym() { return offsetof(SDL_KeyboardEvent, keysym); }
\c size_t GET_OffsetOf_SDL_KeyboardEvent_repeat() { return offsetof(SDL_KeyboardEvent, repeat); }

c-function sdl-init                     SDL_Init                  n -- n
c-function sdl-createwindow             SDL_CreateWindow          a n n n n n -- a
c-function sdl-geterror                 SDL_GetError              -- a
c-function sdl-getwindowsurface         SDL_GetWindowSurface      a -- a
c-function sdl-getwindowpixelformat     SDL_GetWindowPixelFormat  a -- n
c-function sdl-allocformat              SDL_AllocFormat           n -- a
c-function sdl-freeformat               SDL_FreeFormat            a -- void
c-function sdl-fillrect                 SDL_FillRect              a a n -- n
c-function sdl-maprgb                   SDL_MapRGB                a n n n -- n
c-function sdl-updatewindowsurface      SDL_UpdateWindowSurface   a -- n
c-function sdl-delay                    SDL_Delay                 n -- void
c-function sdl-destroywindow            SDL_DestroyWindow         a -- void
c-function sdl-quit                     SDL_Quit                  -- void

c-function sdl-pumpevents               SDL_PumpEvents            -- void
c-function sdl-getkeyboardstate         SDL_GetKeyboardState      a -- a
c-function sdl-waitevent                SDL_WaitEvent             a -- n
c-function sdl-pollevent                SDL_PollEvent             a -- n

c-function c-sizeof-int                 GET_SizeOf_int            -- n
c-function c-sizeof-rect                GET_SizeOf_SDL_Rect       -- n
c-function c-sizeof-event               GET_SizeOf_SDL_Event      -- n

c-function c-offsetof-rect-x            GET_OffsetOf_SDL_Rect_x   -- n
c-function c-offsetof-rect-y            GET_OffsetOf_SDL_Rect_y   -- n
c-function c-offsetof-rect-h            GET_OffsetOf_SDL_Rect_h   -- n
c-function c-offsetof-rect-w            GET_OffsetOf_SDL_Rect_w   -- n
c-function c-offsetof-kbdevt-keysym     GET_OffsetOf_SDL_KeyboardEvent_keysym   -- n
c-function c-offsetof-kbdevt-repeat     GET_OffsetOf_SDL_KeyboardEvent_repeat   -- n

end-c-library

: tocstr over + 1- 0 swap c! ;

needs sdl2constants.fs
