\ main.fs
\ Hannes Hauer
\ Simon Himmelbauer
\ Siegfried Oleg Pammer
\ Description: main source file

needs common/graphics.fs
needs executor/executor.fs
needs compiler/compiler.fs

: step
  assert0( depth 0 = )
  \ print program counter (debug)
  \ s" size: " type codesize hex.
  \ s" pc: " type pc hex.
  \  print-regfile
  \ s" return stack: " type f.s
  \ read instruction word
  image pc + uw@
  dup
  \ print-regfile
  \ s\" raw inst: " type
  \ hex.
  \ s\" \n" type
  drop
  \ and split into nibbles
  dup $f and to nibble2
  4 rshift
  dup $f and to nibble1
  4 rshift
  dup $f and to nibble4
  4 rshift
  $f and to nibble3
  \ move next
  pc 2 + to pc
  \ print nibbles (debug)
  \ s" nibbles: " type
  \ nibble1 hex. nibble2 hex. nibble3 hex. nibble4 hex.
  assert0( depth 0 = )
  \ decode instruction
  \ s" decoded: " type
  decode-instruction dup
  assert0( depth 2 = )
  \ s" op: " type
  \ . \ prints op
  -1 <> if
    \ s" imm: " type
    \ imm .
    \  s" reg1: " type
    \ register1 .
    \ s" reg2: " type
    \ register2 .
    \ s" flag: " type
    \ flag .
    assert0( depth 1 = )
    execute-instruction
    assert0( depth 1 = )
  else
    assert0( depth 1 = )
    drop
    -1
    assert0( depth 1 = )
  endif
  assert0( depth 1 = )
  \ s\" \n ----- \n " type
;

: execute-image
  16 allocate assert0( 0 = ) to chp8-reg
  chp8-reg 16 erase

  begin
    utime assert0( 0 = ) to chp8-timestamp
    assert0( depth 0 = )
    \ process events
    c-sizeof-event allocate assert0( 0 = )
    begin
      dup sdl-pollevent 0 >
    while
      dup 0 + ul@
      SDL_QUIT = if exit endif
    repeat
    free assert0( 0 = )
    step 0<> if
      s\" runtime error\n" type
      exit
    endif
    assert0( depth 0 = )
    \ elapsed µs (per instruction)
    utime assert0( 0 = ) chp8-timestamp -
    \ move to float
    s>f fdup 
    \ adjust timers ticking at 60 Hz
    \ this means we need to subtract 60 per second
    \ (or 60 / 1,000,000 = 6 / 100,000 = 0.00006 per µs)
    6e-5 f* fdup
    \ s" before del" type
    chp8-delay-timer dup f@ fswap f- 0 s>f fmax f!
    \ s" before snd" type
    chp8-sound-timer dup f@ fswap f- 0 s>f fmax f!
    \ convert to ms per instruction (div by 10^3)
    1000 s>f f/ fdup
    \ IPms = 1 / msPI
    1 s>f fswap f/
    \ IPms - 700
    700 s>f f-
    \ * msPI
    f*
    \ convert to int
    f>s
    \ wait
    dup 0 > if ms else drop endif
    \ clear
    assert0( depth 0 = )
    pc codesize >=
  until
;

0 variable USE_COMPILER drop
next-arg s>number? drop USE_COMPILER !
drop

: run
  init-graphics
  USE_COMPILER @ if
    \ see program
    0 program
  else
    execute-image
  endif
  down-graphics
;

run
